hurl(1)

NAME
hurl - run and test HTTP requests.

SYNOPSIS
hurl [OPTIONS] [FILES...] hurl --test [OPTIONS] [FILES...]

DESCRIPTION
Hurl is a command line tool that runs HTTP requests defined in a simple plain text format. It can chain requests, capture values and evaluate queries on headers and body response. Hurl is very versatile, it can be used for fetching data and testing HTTP sessions: HTML content, REST / SOAP / GraphQL APIs, or any other XML / JSON based APIs.
    $ hurl session.hurl If no input files are specified, input is read from stdin.
    $ echo GET http://httpbin.org/get | hurl
        {
          "args": {},
          "headers": {
            "Accept": "*/*",
            "Accept-Encoding": "gzip",
            "Content-Length": "0",
            "Host": "httpbin.org",
            "User-Agent": "hurl/0.99.10",
            "X-Amzn-Trace-Id": "Root=1-5eedf4c7-520814d64e2f9249ea44e0"
          },
          "origin": "1.2.3.4",
          "url": "http://httpbin.org/get"
        } Hurl can take files as input, or directories. In the latter case, Hurl will search files with `.hurl` extension recursively. Output goes to stdout by default. To have output go to a file, use the -o, --output option:
    $ hurl -o output input.hurl By default, Hurl executes all HTTP requests and outputs the response body of the last HTTP call. To have a test oriented output, you can use --test option:
    $ hurl --test *.hurl

HURL FILE FORMAT
The Hurl file format is fully documented in https://hurl.dev/docs/hurl-file.html It consists of one or several HTTP requests
    GET http://example.org/endpoint1
    GET http://example.org/endpoint2

  Capturing values
A value from an HTTP response can be-reused for successive HTTP requests. A typical example occurs with CSRF tokens.
    GET https://example.org
    HTTP 200
    # Capture the CSRF token value from html body.
    [Captures]
    csrf_token: xpath "normalize-space(//meta[@name='_csrf_token']/@content)"
    # Do the login !
    POST https://example.org/login?user=toto&password=1234
    X-CSRF-TOKEN: {{csrf_token}} More information on captures can be found here https://hurl.dev/docs/capturing-response.html

  Asserts
The HTTP response defined in the Hurl file are used to make asserts. Responses are optional. At the minimum, response includes assert on the HTTP status code.
    GET http://example.org
    HTTP 301 It can also include asserts on the response headers
    GET http://example.org
    HTTP 301
    Location: http://www.example.org Explicit asserts can be included by combining a query and a predicate
    GET http://example.org
    HTTP 301
    [Asserts]
    xpath "string(//title)" == "301 Moved" With the addition of asserts, Hurl can be used as a testing tool to run scenarios. More information on asserts can be found here https://hurl.dev/docs/asserting-response.html

CONFIGURATION
Options that exist in curl have exactly the same semantics. Options specified on the command line are defined for every Hurl file's entry, except if they are tagged as cli-only (can not be defined in the Hurl request `[Options]` entry) For instance:
    $ hurl --location foo.hurl will follow redirection for each entry in `foo.hurl`. You can also define an option only for a particular entry with an `[Options]` section. For instance, this Hurl file:
    GET https://example.org
    HTTP 301
    GET https://example.org
    [Options]
    location: true
    HTTP 200 will follow a redirection only for the second entry. Most of the options can also be defined with environment variables (like `HURL_INSECURE` for --insecure). So, in order to configure Hurl, there are three sources from the lowest priority (most easily overridden) to highest (overrides all others):

•   Environment variables (ex: `HURL_INSECURE`)

•   Command-line options (ex: `--insecure`)

•   Options section options (ex: `insecure: true` in file)

ALL OPTIONS

  HTTP options

--aws-sigv4 <PROVIDER1[:PROVIDER2[:REGION[:SERVICE]]]>
    Generate an `Authorization` header with an AWS SigV4 signature. Use -u, --user to specify Access Key Id (username) and Secret Key (password). To use temporary session credentials (e.g. for an AWS IAM Role), add the `X-Amz-Security-Token` header containing the session token.

--cacert <FILE>
    Specifies the certificate file for peer verification. The file may contain multiple CA certificates and must be in PEM format. Normally Hurl is built to use a default file for this, so this option is typically used to alter that default file.

-E, --cert <CERTIFICATE[:PASSWORD]>
    Client certificate file and password. See also --key.

--compressed
    Request a compressed response using one of the algorithms br, gzip, deflate and automatically decompress the content. Environment variables: HURL_COMPRESSED

--connect-timeout <SECONDS>
    Maximum time in seconds that you allow Hurl's connection to take. You can specify time units in the connect timeout expression. Set Hurl to use a connect timeout of 20 seconds with `--connect-timeout 20s` or set it to 35,000 milliseconds with `--connect-timeout 35000ms`. No spaces allowed. See also -m, --max-time. Environment variables: HURL_CONNECT_TIMEOUT

--connect-to <HOST1:PORT1:HOST2:PORT2>
    For a request to the given HOST1:PORT1 pair, connect to HOST2:PORT2 instead. This option can be used several times in a command line. See also --resolve.

--digest
    Tell Hurl to use HTTP Digest authentication

-H, --header <NAME:VALUE>
    Add an extra header to include in information sent. Can be used several times in a command. Do not add newlines or carriage returns. Environment variables: HURL_HEADER='name1:value1|name2:value2' (headers are separated by |)

-0, --http1.0
    Tells Hurl to use HTTP version 1.0 instead of using its internally preferred HTTP version. Environment variables: HURL_HTTP10

--http1.1
    Tells Hurl to use HTTP version 1.1. Environment variables: HURL_HTTP11

--http2
    Tells Hurl to use HTTP version 2. For HTTPS, this means Hurl negotiates HTTP/2 in the TLS handshake. Hurl does this by default. For HTTP, this means Hurl attempts to upgrade the request to HTTP/2 using the Upgrade: request header. Environment variables: HURL_HTTP2

--http3
    Tells Hurl to try HTTP version 3 to the host in the URL, but fallback to earlier HTTP versions if the HTTP/3 connection establishment fails. HTTP/3 is only available for HTTPS and not for HTTP URLs. Environment variables: HURL_HTTP3

-k, --insecure
    This option explicitly allows Hurl to perform "insecure" SSL connections and transfers. Environment variables: HURL_INSECURE

-4, --ipv4
    This option tells Hurl to use IPv4 addresses only when resolving host names, and not for example try IPv6. Environment variables: HURL_IPV4

-6, --ipv6
    This option tells Hurl to use IPv6 addresses only when resolving host names, and not for example try IPv4. Environment variables: HURL_IPV6

--key <KEY>
    Private key file name.

--limit-rate <SPEED>
    Specify the maximum transfer rate you want Hurl to use, for both downloads and uploads. This feature is useful if you have a limited pipe and you would like your transfer not to use your entire bandwidth. To make it slower than it otherwise would be. The given speed is measured in bytes/second. Environment variables: HURL_LIMIT_RATE

-L, --location
    Follow redirect. To limit the amount of redirects to follow use the --max-redirs option Environment variables: HURL_LOCATION

--location-trusted
    Like -L, --location, but allows sending the name + password to all hosts that the site may redirect to. This may or may not introduce a security breach if the site redirects you to a site to which you send your authentication info (which is plaintext in the case of HTTP Basic authentication). Environment variables: HURL_LOCATION_TRUSTED

--max-filesize <BYTES>
    Specify the maximum size in bytes of a file to download. If the file requested is larger than this value, the transfer does not start. Environment variables: HURL_MAX_FILESIZE This is a cli-only option.

--max-redirs <NUM>
    Set maximum number of redirection-followings allowed By default, the limit is set to 50 redirections. Set this option to -1 to make it unlimited. Environment variables: HURL_MAX_REDIRS

-m, --max-time <SECONDS>
    Maximum time in seconds that you allow a request/response to take. This is the standard timeout. You can specify time units in the maximum time expression. Set Hurl to use a maximum time of 20 seconds with `--max-time 20s` or set it to 35,000 milliseconds with `--max-time 35000ms`. No spaces allowed. See also --connect-timeout. Environment variables: HURL_MAX_TIME

--negotiate
    Tell Hurl to use Negotiate (SPNEGO) authentication.

--no-cookie-store
    Do not use cookie storage for requests/responses in a file. By default, requests in the same Hurl file share cookie storage, this option deactivates cookie engine. Environment variables: HURL_NO_COOKIE_STORE This is a cli-only option.

--no-proxy <HOST(S)>
    Comma-separated list of hosts which do not use a proxy. Environment variables: no_proxy

--ntlm
    Tell Hurl to use NTLM authentication

--path-as-is
    Tell Hurl to not handle sequences of /../ or /./ in the given URL path. Normally Hurl will squash or merge them according to standards but with this option set you tell it not to do that.

--pinnedpubkey <HASHES>
    When negotiating a TLS or SSL connection, the server sends a certificate indicating its identity. A public key is extracted from this certificate and if it does not exactly match the public key provided to this option, Hurl aborts the connection before sending or receiving any data.

-x, --proxy <[PROTOCOL://]HOST[:PORT]>
    Use the specified proxy. Environment variables: http_proxy https_proxy all_proxy

--resolve <HOST:PORT:ADDR>
    Provide a custom address for a specific host and port pair. Using this, you can make the Hurl requests(s) use a specified address and prevent the otherwise normally resolved address to be used. Consider it a sort of /etc/hosts alternative provided on the command line.

--ssl-no-revoke
    (Windows) This option tells Hurl to disable certificate revocation checks. WARNING: this option loosens the SSL security, and by using this flag you ask for exactly that. This is a cli-only option.

--unix-socket <PATH>
    (HTTP) Connect through this Unix domain socket, instead of using the network.

-u, --user <USER:PASSWORD>
    Add basic Authentication header to each request. Environment variables: HURL_USER

-A, --user-agent <NAME>
    Specify the User-Agent string to send to the HTTP server. Environment variables: HURL_USER_AGENT This is a cli-only option.

  Output options

--color
    Colorize standard output and standard error. By default, Hurl outputs a prettified and colorized response. When redirected through pipes, standard streams are not colorized and color can be forced with this option. Environment variables: HURL_COLOR This is a cli-only option.

--curl <FILE>
    Export each request to a list of curl commands. This is a cli-only option.

--error-format <FORMAT>
    Control the format of error message (short by default or long). When using long, the response body is logged when there are errors. Environment variables: HURL_ERROR_FORMAT This is a cli-only option.

-i, --include
    Include the HTTP headers in the output This is a cli-only option.

--json
    Output each Hurl file result to JSON. The format is very closed to HAR format. This is a cli-only option.

--no-color
    Do not colorize standard output nor standard error. Environment variables: HURL_NO_COLOR NO_COLOR This is a cli-only option.

--no-output
    Suppress output. By default, Hurl outputs the body of the last response. Environment variables: HURL_NO_OUTPUT This is a cli-only option.

--no-pretty
    Do not prettify response output for supported content type (JSON only for the moment). By default, output is prettified if standard output is a terminal. Environment variables: HURL_NO_PRETTY This is a cli-only option.

-o, --output <FILE>
    Write output to FILE instead of stdout. Use '-' for stdout in [Options] sections.

--pretty
    Prettify response output for supported content type (JSON only for the moment). By default, JSON response is prettified if standard output is a terminal, and colorized, see--no-color to format without color. Environment variables: HURL_PRETTY This is a cli-only option.

--progress-bar
    Display a progress bar in test mode. The progress bar is displayed only in interactive TTYs. This option forces the progress bar to be displayed even in non-interactive TTYs. This is a cli-only option.

-v, --verbose
    Turn on verbose output on standard error stream. Useful for debugging. A line starting with '>' means data sent by Hurl. A line staring with '<' means data received by Hurl. A line starting with '*' means additional info provided by Hurl. If you only want HTTP headers in the output, -i, --include might be the option you're looking for. Environment variables: HURL_VERBOSE

--verbosity <LEVEL>
    Set the verbosity level for debug logs on standard error stream (brief, verbose or debug) If you only want HTTP headers in the output, -i, --include might be the option you're looking for. -v, --verbose is an alias for `--verbosity verbose` --very-verbose is an alias for `--verbosity debug` Environment variables: HURL_VERBOSITY

--very-verbose
    Turn on more verbose output on standard error stream. In contrast to --verbose option, this option outputs the full HTTP body request and response on standard error. In addition, lines starting with '**' are libcurl debug logs. Environment variables: HURL_VERY_VERBOSE

  Run options

--continue-on-error
    Continue executing requests to the end of the Hurl file even when an assert error occurs. By default, Hurl exits after an assert error in the HTTP response. Note that this option does not affect the behavior with multiple input Hurl files. All the input files are executed independently. The result of one file does not affect the execution of the other Hurl files. Environment variables: HURL_CONTINUE_ON_ERROR This is a cli-only option.

--delay <MILLISECONDS>
    Sets delay before each request (aka sleep). The delay is not applied to requests that have been retried because of --retry. See --retry-interval to space retried requests. You can specify time units in the delay expression. Set Hurl to use a delay of 2 seconds with `--delay 2s` or set it to 500 milliseconds with `--delay 500ms`. Supported time units: ms, s, m, h. No spaces allowed. Environment variables: HURL_DELAY

--from-entry <ENTRY_NUMBER>
    Execute Hurl file from ENTRY_NUMBER (starting at 1). This is a cli-only option.

--jobs <NUM>
    Maximum number of parallel jobs in parallel mode. Default value corresponds (in most cases) to the current amount of CPUs. Set to 1 to disable parallel execution of files. See also --parallel. Environment variables: HURL_JOBS This is a cli-only option.

--no-assert
    Ignore all asserts defined in the Hurl file. Environment variables: HURL_NO_ASSERT This is a cli-only option.

--parallel
    Run files in parallel. Each Hurl file is executed in its own worker thread, without sharing anything with the other workers. The default run mode is sequential. Parallel execution is by default in --test mode. See also --jobs. This is a cli-only option.

--repeat <NUM>
    Repeat the input files sequence NUM times, -1 for infinite loop. Given a.hurl, b.hurl, c.hurl as input, repeat two times will run a.hurl, b.hurl, c.hurl, a.hurl, b.hurl, c.hurl.

--retry <NUM>
    Maximum number of retries, 0 for no retries, -1 for unlimited retries. Retry happens if any error occurs (asserts, captures, runtimes etc...). Environment variables: HURL_RETRY

--retry-interval <MILLISECONDS>
    Duration in milliseconds between each retry. Default is 1000 ms. You can specify time units in the retry interval expression. Set Hurl to use a retry interval of 2 seconds with `--retry-interval 2s` or set it to 500 milliseconds with `--retry-interval 500ms`. No spaces allowed. Environment variables: HURL_RETRY_INTERVAL

--secret <NAME=VALUE>
    Define secret value to be redacted from logs and report. When defined, secrets can be used as variable everywhere variables are used. Environment variables: HURL_SECRET_name This is a cli-only option.

--secrets-file <FILE>
    Define a secrets file in which you define your secrets Each secret is defined as name=value exactly as with --secret option. Note that defining a secret twice produces an error. This is a cli-only option.

--test
    Activate test mode: with this, the HTTP response is not outputted anymore, progress is reported for each Hurl file tested, and a text summary is displayed when all files have been run. In test mode, files are executed in parallel. To run test in a sequential way use `--jobs 1`. See also --jobs. Environment variables: HURL_TEST This is a cli-only option.

--to-entry <ENTRY_NUMBER>
    Execute Hurl file to ENTRY_NUMBER (starting at 1). Ignore the remaining of the file. It is useful for debugging a session. This is a cli-only option.

--variable <NAME=VALUE>
    Define variable (name/value) to be used in Hurl templates. Environment variables: HURL_VARIABLE_name

--variables-file <FILE>
    Set properties file in which your define your variables. Each variable is defined as name=value exactly as with --variable option. Note that defining a variable twice produces an error. This is a cli-only option.

  Report options

--report-html <DIR>
    Generate HTML report in DIR. If the HTML report already exists, it will be updated with the new test results. This is a cli-only option.

--report-json <DIR>
    Generate JSON report in DIR. If the JSON report already exists, it will be updated with the new test results. This is a cli-only option.

--report-junit <FILE>
    Generate JUnit File. If the FILE report already exists, it will be updated with the new test results. This is a cli-only option.

--report-tap <FILE>
    Generate TAP report. If the FILE report already exists, it will be updated with the new test results. This is a cli-only option.

  Other options

-b, --cookie <FILE>
    Read cookies from FILE (using the Netscape cookie file format). Combined with -c, --cookie-jar, you can simulate a cookie storage between successive Hurl runs. This is a cli-only option.

-c, --cookie-jar <FILE>
    Write cookies to FILE after running the session. The file will be written using the Netscape cookie file format. Combined with -b, --cookie, you can simulate a cookie storage between successive Hurl runs. This is a cli-only option.

--file-root <DIR>
    Set root directory to import files in Hurl. This is used for files in multipart form data, request body and response output. When it is not explicitly defined, files are relative to the Hurl file's directory. This is a cli-only option.

--glob <GLOB>
    Specify input files that match the given glob pattern. Multiple glob flags may be used. This flag supports common Unix glob patterns like *, ? and []. However, to avoid your shell accidentally expanding glob patterns before Hurl handles them, you must use single quotes or double quotes around each pattern. This is a cli-only option.

-n, --netrc
    Scan the .netrc file in the user's home directory for the username and password. See also --netrc-file and --netrc-optional.

--netrc-file <FILE>
    Like --netrc, but provide the path to the netrc file. See also --netrc-optional.

--netrc-optional
    Similar to --netrc, but make the .netrc usage optional. See also --netrc-file.

-h, --help
    Usage help. This lists all current command line options with a short description.

-V, --version
    Prints version information

EXIT CODES

  0
Success.

  1
Failed to parse command-line options.

  2
Input file parsing error.

  3
Runtime error (such as failure to connect to host).

  4
Assert error.

WWW
https://hurl.dev

SEE ALSO
curl(1) hurlfmt(1)